﻿@page "/calendar"
@inject IJSRuntime JSRuntime
@inject HttpClient Http
@inject NavigationManager navManager

<div class="d-flex gap-4 mx-4 mt-4 justify-space-between flex-column">
	@if (wasteCollectionTasks.Count != 0)
	{
		<MudCard>
			<MudCardActions>
				<MudIconButton Icon="@Icons.Material.Filled.ArrowBack" Color="Color.Primary" OnClick="Decrement" />
				<MudText Typo="Typo.h6">
					@if (browserLanguage.StartsWith("nl"))
					{
						<text>Afvalophaling van @first.ToString("dddd MMMM dd", new CultureInfo("nl-NL")) tot @later.ToString("dddd, MMMM dd", new CultureInfo("nl-NL"))</text>
					}
					else
					{
						<text>Garbage collection from @first.ToString("dddd MMMM dd", new CultureInfo("en-US")) until @later.ToString("dddd, MMMM dd", new CultureInfo("en-US"))</text>
					}
				</MudText>
				<MudIconButton Icon="@Icons.Material.Filled.ArrowForward" Color="Color.Primary" OnClick="Increment" />
			</MudCardActions>
		</MudCard>
		<MudTimeline TimelinePosition="TimelinePosition.Start" DisableModifiers=false>
			@foreach (var task in tasks)
			{
				<MudTimelineItem Size="Size.Small" Color="Color.Info" Elevation="25" Style="max-width: 300px;">
					<MudCard Outlined=true Elevation="25">
						<MudCardContent>
							<div class="d-flex align-center">
								@if (task.Label.Equals("GFT"))
								{
									<MudIcon Icon=@Icons.Custom.Uncategorized.FoodApple />
								}
								else if (task.Label.Equals("GLAS"))
								{
									<MudIcon Icon=@Icons.Material.Filled.WineBar />
								}
								else if (task.Label.Equals("PAPIER"))
								{
									<MudIcon Icon=@Icons.Material.Filled.Article />
								}
								else if (task.Label.Equals("PMD"))
								{
									<MudIcon Icon=@Icons.Material.Filled.Battery0Bar />
								}
								else if (task.Label.Equals("GROFVUIL"))
								{
									<MudIcon Icon=@Icons.Material.Filled.TableBar />
								}
								else
								{
									<MudIcon Icon=@Icons.Material.Filled.DeleteOutline />
								}
								@* @Icons.Material.Filled.BrunchDining *@
								<MudText Typo="Typo.h6" Class="pl-2">@task.Label</MudText>
							</div>
							<MudText Typo="Typo.body2">@task.Datum.ToString("dddd MMMM dd")</MudText>
						</MudCardContent>
					</MudCard>
				</MudTimelineItem>
			}
		</MudTimeline>
	}
	else
	{
		<p>Fetching garbage collection data...</p>
	}
</div>

@code {
	private DateTime first;
	private DateTime later;
	private int offset;
	private List<WasteCollectionTask> wasteCollectionTasks = new List<WasteCollectionTask>();
	private List<WasteCollectionTask> tasks = new List<WasteCollectionTask>();
	private DateTime selectedDate = DateTime.Today;
	private string browserLanguage = "en-US";
	private bool isValid;
	private MudForm form;
	private Address address = new Address();

	protected override async Task OnInitializedAsync()
	{
		try
		{
			address = await Http.GetFromJsonAsync<Address>($"api/getaddress");
			RetrieveJson();
			offset = 0;
		}
		catch (Exception ex)
		{
			navManager.NavigateTo("/changeaddress");
		}
	}

	private async Task RetrieveJson()
	{
		wasteCollectionTasks = await Http.GetFromJsonAsync<List<WasteCollectionTask>>($"api/garbagecollection?ivagoStreet={Uri.EscapeDataString(address.IvagoStreet)}&number={Uri.EscapeDataString(address.Number)}");
		await GetTasks();
	}

	private async Task GetTasks()
	{
		first = DateTime.Now.AddDays(offset * 14);
		later = DateTime.Now.AddDays(14 + offset * 14);
		tasks = wasteCollectionTasks.Where(t => t.Datum.Date >= first.Date && t.Datum.Date <= later).ToList();
		StateHasChanged();
	}

	private async void Increment()
	{
		offset++;
		await GetTasks();
	}

	private async void Decrement()
	{
		offset--;
		await GetTasks();
	}
}
